﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Documents.Layout;
using Telerik.Windows.Documents.Model;
using System.Windows.Controls;

namespace Telerik.Windows.Documents.UI
{
    public class DocumentModelTreeViewer : Grid
    {
        private System.Windows.Controls.TreeView treeView;

        public DocumentModelTreeViewer()
        {
            this.treeView = new System.Windows.Controls.TreeView();            
            this.Children.Add(treeView);
        }

        public void DisplayDocumentLayoutTree(RadDocument document)
        {
            this.treeView.Items.Clear();
            TreeViewItem root = new TreeViewItem();
            this.treeView.Items.Add(root);
            this.DisplayDocumentLayoutTree(document, root);
        }

        private void DisplayDocumentLayoutTree(DocumentElement modelRoot, System.Windows.Controls.HeaderedItemsControl treeRoot)
        {
            if (modelRoot == null)
            {
                return;
            }

            string header = modelRoot.GetType().Name;
            if (modelRoot is Span)
            {
                string text = string.Empty;
                Span span = ((Span)modelRoot);
                header = span.Text;
            }
            
            treeRoot.Header = header;

            foreach (DocumentElement childElement in modelRoot.Children)
            {
                TreeViewItem childItem = new TreeViewItem();
                treeRoot.Items.Add(childItem);
                this.DisplayDocumentLayoutTree(childElement, childItem);
            }
        }
    }
}
