﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using Telerik.Windows.Documents.Model;
using Microsoft.Win32;
using System.IO;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Docx;
using Telerik.Windows.Documents.FormatProviders.Xaml;
using Telerik.Windows.Documents.Model.Styles;
using Telerik.Windows.Documents.Layout;
using Telerik.Windows.Examples.RichTextBox.SampleData;
using Telerik.Windows.Controls;
using Telerik.Windows.Documents.UI;
using Telerik.Windows.Documents.RichTextBoxCommands;
using Telerik.Windows.Controls.RichTextBoxUI;
using Telerik.Windows.Controls.RibbonView;
using System.Reflection;
using Telerik.Windows.Documents.FormatProviders;
using Telerik.Windows.Documents.FormatProviders.Txt;
using Telerik.Windows.Documents;
using System.Windows.Media;

namespace MailMerge
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();
            this.editor.Loaded += editor_Loaded;
            this.editor.DocumentChanged += editor_DocumentChanged;
        }

        private void editor_Loaded(object sender, RoutedEventArgs e)
        {
            this.editor.Document.MailMergeDataSource.ItemsSource = new ExamplesDataContext().Employees;
        }

        void editor_DocumentChanged(object sender, EventArgs e)
        {
            this.editor.Document.MailMergeDataSource.ItemsSource = new ExamplesDataContext().Employees;
        }

        #region RibbonBarMethodsAndEvents

        private bool IsSupportedImageFormat(string extension)
        {
            if (extension != null)
            {
                extension = extension.ToLower();
            }

            return extension == ".jpg" ||
                extension == ".jpeg" ||
                extension == ".png" ||
                extension == ".bmp";
        }

        private void Statistics_Click(object sender, RoutedEventArgs e)
        {
            string statistics = this.editor.Document.GetStatisticsInfo().ToString();
            MessageBox.Show(statistics, "Document Statistics", MessageBoxButton.OK);
        }

        private void ViewDocumentStructure_Click(object sender, RoutedEventArgs e)
        {
            RadWindow window = new RadWindow();

            DocumentModelTreeViewer documentTreeViewer = new DocumentModelTreeViewer();
            //documentTreeViewer.DisplayDocumentLayoutTree(this.editor.Document);

            window.Content = documentTreeViewer;
            window.Owner = this;

            window.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            window.Width = 600;
            window.Height = 750;

            window.Owner = this;
            window.ShowDialog();
        }

        private void editor_Drop(object sender, DragEventArgs e)
        {
            RadRichTextBox editor = (RadRichTextBox)sender;
            FileInfo[] droppedFiles = e.Data.GetData(DataFormats.FileDrop) as FileInfo[];

            foreach (FileInfo droppedFile in droppedFiles)
            {
                if (this.IsSupportedImageFormat(droppedFile.Extension))
                {
                    using (Stream imageStream = droppedFile.OpenRead())
                    {
                        editor.InsertImage(imageStream, droppedFile.Extension);
                    }
                }
            }
        }

        #endregion


        private void merge_Click(object sender, RoutedEventArgs e)
        {
            editor.Document.MailMergeDataSource.MoveToFirst();
            RadDocument resultDoc = editor.Document.MailMergeCurrentRecord();
            this.editor.Document = resultDoc;
        }
    }
}
